/******************************************************************************
 *	eventwr.c:	Cxg̕`
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 *
 *	@\:
 *	̃vÓAeCxg̓eiԁjEBhEɕ`悵܂B
 *	AChCxgł̓}EX|C^݈̌ʒuiO[oWnjA
 *	}EX֌W̃Cxgł̓{^̃Abv_Eу_uNbNA
 *	L[_ECxgłASCIIR[hAVtgL[rbgeXA^C
 *	ŕ`悵܂B
 *	_uNbN̓CxgƂĒm炳̂ł͂ȂAQx}EX̃{^
 *	NbNꂽԂ̍𒲂ׂāAAvP[VŔfȂĂ͂
 *	܂B
 *
 *	gp@:	}EXAL[{[h̑sB
 */
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "eventwr.h"		/* ̃vOŗL̃wb_t@C	*/

char _sxkernelcomm[] = SXKERNEL;	/* J[lNR}h		*/

/******************************************************************************
 *	main():		C֐
 ******************************************************************************
 */
int main(void)
{
	ComVal cv;			/* ʕϐ			*/

	if (!init(&cv)) {		/* s		*/
		showErrDialog(&cv);	/* G[_CAO\	*/
		cv.endFlag = TRUE;	/* ItOZbg	*/
	}
	/* ItOZbg܂Ń[v */
	while (!cv.endFlag) {
		cv.errorCode = 0;	/* G[R[hNA	*/
		/* ^XN}Cxg擾 */
		TSEventAvail(cv.eventMask, &cv.event);
		/* JgOtɂ */
		GMSetGraph(&cv.windowPtr->graph);

		/* eCxgɑΉs */
		switch (cv.event.ts.what) {
		case E_IDLE:		/* AChCxg		*/
			idleEvent(&cv);
			break;
		case E_MSLDOWN:		/* }EXtg_ECxg	*/
			msLDownEvent(&cv);
			break;
		case E_MSLUP:		/* }EXtgAbvCxg	*/
			msLUpEvent(&cv);
			break;
		case E_MSRDOWN:		/* }EXCg_ECxg	*/
			msRDownEvent(&cv);
			break;
		case E_MSRUP:		/* }EXCgAbvCxg	*/
			msRUpEvent(&cv);
			break;
		case E_KEYDOWN:		/* L[_ECxg		*/
			keyDownEvent(&cv);
			break;
		case E_UPDATE:		/* Abvf[gCxg		*/
			updateEvent(&cv);
			break;
		case E_ACTIVATE:	/* ANeBx[gCxg	*/
			activateEvent(&cv);
			break;
		case E_SYSTEM1:		/* VXeCxg		*/
		case E_SYSTEM2:
			systemEvent(&cv);
			break;
		}
		if (cv.errorCode != 0)	/* G[H		*/
			showErrDialog(&cv); /* G[_CAO\ */
	}
	/* I葱s */
	endProc(((cv.errorCode == 0) ? EXIT_SUCCESS : EXIT_FAILURE), &cv);

	return 0;
}

/******************************************************************************
 *	init():		
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: siIj
 *	:	ʕϐ̏AA{[g֐̓o^AEBhE̍쐬
 *		\ȂǂsB
 */
BOOLEAN init(ComVal *pcv)
{
	int i;

	pcv->windowPtr = NULL;		/* EBhE|C^		*/
	pcv->activeFlag = FALSE;	/* ANeButO		*/
	pcv->eventMask = EVENTMASK;	/* Cxg}XN		*/
	pcv->errorCode = 0;		/* G[R[h			*/
	pcv->endFlag = FALSE;		/* ItO			*/
	pcv->lastLpt = 0;		/* Õ|C^W		*/
	pcv->lastTime[MSL] = 0;		/* }EX̃{^Ōɉꂽ */
	pcv->lastTime[MSR] = 0;
	for (i = 0; i < 6; i++)
		pcv->dispStr[i][0] = 0;	/* \			*/

	TSSetAbort(endProc, (long) pcv); /* A{[g֐o^	*/

	if (LOWWORD(SXVer()) < SXVER2) { /* rwVXẽo[W𒲂ׂ */
		pcv->errorCode = 1;	/* o[WQÂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	if (!createWindow(pcv)) {	/* EBhE쐬		*/
		pcv->errorCode = 2;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	GMSetGraph(&pcv->windowPtr->graph); /* JgOtɂ */
	GMForeColor(G_BLACK);		/* tHAOEhJ[ɂ */
	/* obNOEhJ[CgO[ɂ */
	GMBackColor(G_LGRAY);
	GMFontMode(G_PSET);		/* tHg[hPSETɂ	*/

	WMShow(pcv->windowPtr);		/* EBhE\		*/
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	createWindow():	EBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createWindow(ComVal *pcv)
{
	int paramFlags;			/* p[^̗L		*/
	Rect rc;
	Task task;			/* ^XNǗR[h		*/

	static Rect winSize = { 0, 0, WIN_H, WIN_V }; /* EBhETCY */

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	paramFlags = TSTakeParam(	/* R}hC͂	*/
		task.command,		/* R}hC		*/
		&rc,			/* w肳ꂽEBhEʒu	*/
		NULL,			/* ŏIi[Ȃ	*/
		0,			/* AhXe[uۑȂ	*/
		NULL,			/* AhXe[u쐬Ȃ	*/
		NULL);			/* |C^mۂȂ		*/
	if (!(paramFlags & 1)) {	/* EBhEʒu̎w肪邩H */
		/* ȂꍇAVXeEBhE̍W擾 */
		rc = winSize;
		GMSlideRect(&rc, TSGetWindowPos());
	}

	pcv->windowPtr = WMOpen(	/* EBhEI[v	*/
		NULL,			/* EBhE|C^mۂ	*/
		&rc,			/* EBhE̕\ʒu		*/
		WINTITLE,		/* EBhE^Cg		*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		WI_STD2 << 4,		/* ^Cg̍LWEBhE	*/
		W_FRONT,		/* ԎOɕ\		*/
		TRUE,			/* N[Y{^gp	*/
		TSGetID());		/* ̃^XNhc		*/
	if (pcv->windowPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	idleEvent():	AChCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	݂̃|C^W̕\sB
 */
void idleEvent(ComVal *pcv)
{
	Point pt;

	pt = pcv->event.ev.where;	/* |C^W擾	*/
	if (pcv->lastLpt != pt.x_y) {	/* }EXړH		*/
		/* \쐬 */
		sprintf(pcv->dispStr[PTX], "%4d\0", pt.p.x);
		sprintf(pcv->dispStr[PTY], "%4d\0", pt.p.y);
		drawDispStr(pcv, PTX);	/* \`悷		*/
		drawDispStr(pcv, PTY);
		pcv->lastLpt = pt.x_y;	/* ݂̃|C^Wۑ	*/
	}
}

/******************************************************************************
 *	msLDownEvent():	}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	EBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂIAEBhËړ\ƂȂ܂B
 */
void msLDownEvent(ComVal *pcv)
{
	int partCode;			/* EBhẼp[gR[h	*/
	Window *wTemp;			/* e|EBhE|C^	*/

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* EBhECANeBuŁAOPT.1L[ĂȂH */
		if (!pcv->activeFlag && !(pcv->event.ev.how & KS_OPT1)) {
			/* EBhEANeBuɂ */
			WMSelect(pcv->windowPtr);
			/* {^ꂽꏊ̃p[gR[h擾 */
			partCode = WMFind(pcv->event.ev.where.x_y, &wTemp);
			/* ^Cgo[ȊOŁAEBhE̊OA
			   {^ꂽH */
			if (partCode != W_INDRAG && partCode != W_ININSIDE
			 || !EMLStill())
				return;
		}
		/* }EX̃{^ĂԁAEBhE̊e폈
		   VXeɔCāA{^ꂽA܂͗ꂽꏊ
		   p[gR[h擾 */
		partCode = SXCallWindM(pcv->windowPtr, &pcv->event);
		switch (partCode) {
		case W_INCLOSE:		/* N[Y{^		*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
			break;
		case W_ININSIDE:	/* EBhE̓		*/
			/* }EX̃{^_EԂ`悷 */
			drawMSDown(pcv, MSL);
			break;
		}
	}
}

/******************************************************************************
 *	msLUpEvent():	}EXtgAbvCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̍{^ꂽꍇ̏sB
 */
void msLUpEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr)
		/* }EX̃{^AbvԂ`悷 */
		drawMSUp(pcv, MSL);
}

/******************************************************************************
 *	msRDownEvent():	}EXCg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̉E{^ꂽꍇ̏sB
 */
void msRDownEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr)
		/* }EX̃{^_EԂ`悷 */
		drawMSDown(pcv, MSR);
}

/******************************************************************************
 *	msRUpEvent():	}EXCgAbvCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̉E{^ꂽꍇ̏sB
 */
void msRUpEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr)
		/* }EX̃{^AbvԂ`悷 */
		drawMSUp(pcv, MSR);
}

/******************************************************************************
 *	keyDownEvent():	L[_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	OPT.1+'Q'L[ł̏IsB
 */
void keyDownEvent(ComVal *pcv)
{
	int shortCut;			/* V[gJbgL[		*/

	if (pcv->event.ev.how & KS_OPT1) { /* OPT.1L[ꂽH	*/
		/* L[͂啶ɕϊ */
		shortCut = toupper((int) pcv->event.ev.whom.key.ascii);
		if (shortCut == 'Q')	/* IH			*/
			pcv->endFlag = TRUE; /* ItOZbg	*/
	}
	/* \쐬 */
	sprintf(pcv->dispStr[ASC], " %-2c\0", pcv->event.ev.whom.key.ascii);
	sprintf(pcv->dispStr[SFT], " %08x \0", pcv->event.ev.how);
	drawDispStr(pcv, ASC);		/* \`悷		*/
	drawDispStr(pcv, SFT);
}

/******************************************************************************
 *	updateEvent():	Abvf[g
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	Abvf[gƂăEBhE`悷B
 *	̏sȂƁA艺̃EBhẼAbvf[gACh
 *	Cxg̏łȂȂ܂B
 */
void updateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		WMUpdate(pcv->windowPtr); /* Abvf[gJn	*/
		drawGraph(pcv);		/* EBhE`悷	*/
		WMUpdtOver(pcv->windowPtr); /* Abvf[gI	*/
	}
}

/******************************************************************************
 *	drawGraph():	EBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawGraph(ComVal *pcv)
{
	int i;

	static Rect strFrame[6] = {	/* \t[		*/
		{ STR1_X - 2, STR1_Y - 1, STR1_X +  4 * 6 + 2, STR1_Y + 12 + 2 },
		{ STR2_X - 2, STR2_Y - 1, STR2_X +  4 * 6 + 2, STR2_Y + 12 + 2 },
		{ STR3_X - 2, STR3_Y - 1, STR3_X + 14 * 6 + 2, STR3_Y + 12 + 2 },
		{ STR4_X - 2, STR4_Y - 1, STR4_X + 14 * 6 + 2, STR4_Y + 12 + 2 },
		{ STR5_X - 2, STR5_Y - 1, STR5_X +  3 * 6 + 2, STR5_Y + 12 + 2 },
		{ STR6_X - 2, STR6_Y - 1, STR6_X + 10 * 6 + 2, STR6_Y + 12 + 2 }
	};

	/* JgOt́Ałɐݒ肳Ă */

	/* Œ蕶`悷 */
	GMShadowStrZ("|C^W(X,Y)", LONGWORD(TTL1_X, TTL1_Y));
	GMShadowStrZ("}EX{^",    LONGWORD(TTL2_X, TTL2_Y));
	GMShadowStrZ("}EXE{^",    LONGWORD(TTL3_X, TTL3_Y));
	GMShadowStrZ("L[{[h",        LONGWORD(TTL4_X, TTL4_Y));
	for (i = 0; i < 6; i++)
		GMShadowRect(&strFrame[i]); /* \t[`悷 */
	drawDispStr(pcv, ALL);		/* \`悷		*/
}

/******************************************************************************
 *	activateEvent():	ANeBx[gCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	ANeBuACANeBuɂANeButO̐؂ւƁA
 *		Cxg}XN̐؂ւsB
 */
void activateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		pcv->activeFlag = TRUE;	/* ANeButOZbg	*/
		/* ANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK | EM_KEYDOWN;
	/* Cxg̃EBhEŁAANeBuԂH */
	} else if (pcv->activeFlag) {
		pcv->activeFlag = FALSE; /* ANeButONA */
		/* CANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK;
	}
}

/******************************************************************************
 *	systemEvent():	VXeCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	SEBhẼN[YAS^XN̏IAEBhẼZNg
 *		ΉsB
 */
void systemEvent(ComVal *pcv)
{
	switch (pcv->event.ts.what2) {	/* Cxg̎ނ́H		*/
	case CLOSEALL:			/* SEBhẼN[Y	*/
	case ENDTSK:			/* S^XN̏I		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		break;
	case WINDOWSELECT:		/* EBhẼZNg		*/
		WMSelect(pcv->windowPtr); /* EBhEANeBuɂ */
		break;
	}
}

/******************************************************************************
 *	showErrDialog():	G[_CAO̕\
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void showErrDialog(ComVal *pcv)
{
	int i;

	static struct {			/* G[			*/
		int code;		/* G[R[h			*/
		int manager;		/* gp}l[W		*/
		int flag;		/* \tbO			*/
		char *message;		/* G[bZ[W		*/
	} errInfo[] = {
		{ 1, 1, D_RED,    "SX SYSTEM̃o[WႢ܂B" },
		{ 2, 2, D_RED,    "EBhE쐬ł܂B" },
		{ 0, 1, D_YELLOW, "G[܂B" }
	};

	for (i = 0; errInfo[i].code != 0; i++) /* G[R[h{	*/
		if (errInfo[i].code == pcv->errorCode)
			break;
	switch (errInfo[i].manager) {	/* }l[W̑I		*/
	case 1:				/* _CAO}		*/
		DMError(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	case 2:				/* ^XN}			*/
		TSErrDialogN(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	}
}

/******************************************************************************
 *	endProc():	I葱
 ******************************************************************************
 *	:	int code	IR[h
 *		ComVal *pcv	ʕϐւ̃|C^
 *	:	nh̉EBhE̔pƁAvȌIsB
 */
void endProc(int code, ComVal *pcv)
{
	/* EBhE|C^mۂꂽ܂܂H */
	if (pcv->windowPtr != NULL)
		WMDispose(pcv->windowPtr); /* EBhEp	*/

	exit(code);			/* vOI		*/
}

/******************************************************************************
 *	drawMSDown():	}EX{^_ECxg̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int mode	\̎ށiMSL, MSRj
 */
void drawMSDown(ComVal *pcv, int mode)
{
	/* }EX̍{^_uNbNꂽH */
	if (pcv->event.ts.when - pcv->lastTime[mode] <= EMDClickGet()) {
		pcv->lastTime[mode] = 0;
		/* \쐬 */
		sprintf(pcv->dispStr[mode], " %-13s", "DOUBLE CLICK");
	} else
		/* \쐬 */
		sprintf(pcv->dispStr[mode], " %-13s", "DOWN");
	drawDispStr(pcv, mode);		/* \`悷		*/
	/* ŌɃ}EX̃{^ꂽԂݒ肷 */
	pcv->lastTime[mode] = pcv->event.ts.when;
}

/******************************************************************************
 *	drawMSUp():	}EX{^AbvCxg̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int mode	\̎ށiMSL, MSRj
 */
void drawMSUp(ComVal *pcv, int mode)
{
	/* \쐬 */
	sprintf(pcv->dispStr[mode], " %-13s", "U P");
	drawDispStr(pcv, mode);		/* \`悷		*/
}

/******************************************************************************
 *	drawDispStr():	\̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int mode	\̎ށiALL`SFTj
 */
void drawDispStr(ComVal *pcv, int mode)
{
	int i;

	static LPoint strPos[6] = {	/* \ʒu		*/
		LONGWORD(STR3_X, STR3_Y), /* }EX{^		*/
		LONGWORD(STR4_X, STR4_Y), /* }EXE{^		*/
		LONGWORD(STR1_X, STR1_Y), /* |C^Ww		*/
		LONGWORD(STR2_X, STR2_Y), /*      V     x		*/
		LONGWORD(STR5_X, STR5_Y), /* ASCIIR[hiL[{[hj	*/
		LONGWORD(STR6_X, STR6_Y)  /* VtgL[rbgi V  j	*/
	};

	/* JgOt́Ałɐݒ肳Ă */

	if (mode != ALL) {
		GMMove(strPos[mode]);	/* yẅʒuֈړ	*/
		GMDrawStrZ(pcv->dispStr[mode]); /* `悷	*/
	} else
		for (i = 0; i < 6; i++) {
			GMMove(strPos[i]); /* yẅʒuֈړ */
			GMDrawStrZ(pcv->dispStr[i]); /* `悷 */
		}
}
